﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Npgsql;
using Nyilvantarto.mdl;
using Nyilvantarto.mdl.ent;

namespace Nyilvantarto
{
    /// <summary>
    /// Az új dolgozók felvételére szolgáló űrlap eseményeit kezelő osztály.
    /// </summary>
    public partial class UjDolgozo : Form
    {
        private DataConnection Kapcsolat;

        /// <summary>
        /// Alapértelmezett konstruktor.
        /// </summary>
        public UjDolgozo()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Konsturtor, amelyben átadható egy referencia az adatbázis-kapcsolatra.
        /// </summary>
        /// <param name="Connection">A kapcsolat referenciája</param>
        public UjDolgozo(DataConnection Connection)
        {
            InitializeComponent();
            this.Kapcsolat = Connection;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Dolgozo dolg = new Dolgozo(nevBox.Text, szamBox.Text, szulDatumBox.Value, beosztasBox.Text,
                szerzodesSzoveg.Text, probaido.Checked, egyho.Checked ? 1 : 3); 
            Kapcsolat.insertDolgozo(dolg);
            Kapcsolat.disconnect();
            this.Hide();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Hide();
        }
    }
}
