﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Nyilvantarto.mdl;
using Nyilvantarto.mdl.ent;
using Nyilvantarto.mdl.ent.types;

namespace Nyilvantarto
{
    public partial class UjJarmu : Form
    {
        private DataConnection kapcsolat;

        public UjJarmu()
        {
            InitializeComponent();
        }

        public UjJarmu(DataConnection d)
        {
            InitializeComponent();
            kapcsolat = d;

        }

        private void szemelyauto_CheckedChanged(object sender, EventArgs e)
        {
            if (szemelyauto.Checked == false)
            {
                szemelyautoSpecifikus.Visible = false;
            }
            else if (szemelyauto.Checked == true)
            {
                szemelyautoSpecifikus.Visible = true;
            }
            if (teherauto.Checked == false)
            {
                teherautoSpecifikus.Visible = false;
            }
            else if (teherauto.Checked == true)
            {
                teherautoSpecifikus.Visible = true;
            }
            if (munkagep.Checked == false)
            {
                munkagepSpecifikus.Visible = false;
            }
            else if (munkagep.Checked == true)
            {
                munkagepSpecifikus.Visible = true;
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Hide();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                Jarmu j = null;
                if (szemelyauto.Checked)
                {
                    j = new Szemelyauto(alvazszamText.Text, benzinRadio.Checked ? "benzin" : "diesel", gyartoText.Text,
                        tipusText.Text, new List<TankolasRekord>(), int.Parse(csomagtartoMeretText.Text),
                        int.Parse(utasMaxText.Text));
                }
                else if (teherauto.Checked)
                {
                    j = new Teherauto(alvazszamText.Text, gyartoText.Text, benzinRadio.Checked ? "benzin" : "diesel",
                        tipusText.Text, new List<TankolasRekord>(), int.Parse(kapacitasText.Text));
                }
                else
                {
                    j = new Munkagep(alvazszamText.Text, benzinRadio.Checked ? "benzin" : "diesel", gyartoText.Text,
                        tipusText.Text, new List<TankolasRekord>(), munkagepFajtaText.Text,
                        int.Parse(munkagepMotorEroText.Text));
                }

                kapcsolat.insertJarmu(j);

                this.Hide();
            }
            catch (FormatException f)
            {
                MessageBox.Show("Hiba történt a megadott adatok feldolgozása során. Ellenőrizze, hogy a megadott értékek formátuma megfelelő-e.", "Hiba", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }

    }
}
