﻿/*
 * 'A PostgreSQL objektumrelációs lehetőségei'
 * Szakdolgozat
 * Cser Lajos, Szegedi Tudományegyetem, 2013.
 *
 * Jarmu_generator(INTEGER, eng_jarmu_tipusok):
 * Ez a függvény a minta adatok generálására szolgál (az első paraméterben adhatjuk meg, hogy
 * összesen hány jármű generálódjon, a másodikban pedig azt, milyen típusú objektumokra van
 * szükségünk.) 
 * Nem garantált, hogy a generált adatokat sikeresen beszúrja; ha valamelyik
 * véletlengenerált adat elsődleges kulcsa egyezik a táblában lévő adatok valamelyikével, 
 * a kulcs feltétel miatt a beszúrás meghiúsul - ez azonban kis valószínűségű.
 */

CREATE TYPE eng_jarmu_tipusok AS ENUM('teherauto', 'munkagep', 'szemelyauto');

CREATE OR REPLACE FUNCTION Jarmu_generator(darab INTEGER, tipus eng_jarmu_tipusok) RETURNS VOID AS
$$
DECLARE
	i INTEGER = 0;
	j INTEGER = 0;
	m INTEGER;
	alvszam CHARACTER VARYING = '5';
	umax INTEGER = 4;
	uanyag CHARACTER VARYING;
	gyar CHARACTER VARYING;
	tip CHARACTER VARYING;
	csommeret INTEGER;
	karakterek CHAR[] = '{A,F,G,W,D,B,E,0,1,2,3,4,5,6,7,8,9}';
	uzemanyagok CHARACTER VARYING[] = '{"benzin", "diesel"}';
	szemautok CHARACTER VARYING[][] = '{ {"Mercedes-Benz", "C220"}, {"Toyota", "Yaris"},  {"Toyota", "Avensis"}, {"Mercedes-Benz", "E220"}, {"BMW", "330d"}, {"Ford", "Fiesta"}, {"Peugeot", "301"}, {"Citroen", "C4"}, {"Toyota", "Corolla"}, {"Chevrolet", "Spark"}, {"Audi", "A4"}, {"Audi", "A3"}, {"Volkswagen", "Golf"}, {"Smart", "Forfour"} }';
	kapacitas INTEGER;
	teherautok CHARACTER VARYING[][] = '{ {"IFA", "W50"}, {"IFA", "L60"}, {"DAF", "95 XF"}, {"DAF", "CF 85"}, {"Mercedes-Benz", "L1318"} }';
BEGIN
IF tipus = 'szemelyauto' THEN
	/* Új személyautókat generálunk */
	WHILE i < darab LOOP
		uanyag = uzemanyagok[CAST (random() + 1 AS INTEGER)];
		m = CAST (random() * (array_length(szemautok, 1) - 1) + 1 AS INTEGER);
		gyar = szemautok[m][1];
		tip = szemautok[m][2];
		/* 'Alvázszám' generálása */
		WHILE j < 14 LOOP
			m = CAST (random() * (array_length(karakterek,1)-1) + 1 AS INTEGER);
			alvszam = alvszam || CAST (karakterek[m] AS CHARACTER VARYING);
			j = j + 1;
		END LOOP;
		csommeret = CAST (random() * 130 + 120 AS INTEGER);
		m = CAST (random() AS INTEGER);
		umax = umax + m;
		INSERT INTO Szemelyauto VALUES (
			alvszam,
			uanyag,
			gyar,
			tip,
			'{}',
			umax,
			csommeret
		);
		alvszam = CAST (CAST(random()*9 AS INTEGER) AS CHARACTER VARYING);
		j = 0;
		i = i + 1;
		umax = 4;
	END LOOP;
ELSIF tipus = 'munkagep' THEN
	/* Munkagépeket generálunk */
	uanyag = 'diesel';
	WHILE i < darab LOOP
		WHILE j < 14 LOOP
			m = CAST (random() * (array_length(karakterek,1)-1) + 1 AS INTEGER);
			alvszam = alvszam || CAST (karakterek[m] AS CHARACTER VARYING);
			j = j + 1;
		END LOOP;

		INSERT INTO Munkagep VALUES (
			alvszam,
			uanyag
		);
		j = 0;
		i = i + 1;
		alvszam = CAST (CAST(random()*9 AS INTEGER) AS CHARACTER VARYING);
	END LOOP;
ELSE
	uanyag = 'diesel';
	/* Teherautókat generálunk */
	WHILE i < darab LOOP
		WHILE j < 14 LOOP
			m = CAST (random() * (array_length(karakterek,1)-1) + 1 AS INTEGER);
			alvszam = alvszam || CAST (karakterek[m] AS CHARACTER VARYING);
			j = j + 1;
		END LOOP;
		m = CAST (random() * (array_length(teherautok, 1) - 1) + 1 AS INTEGER);
		gyar = teherautok[m][1];
		tip = teherautok[m][2];
		kapacitas = CAST (random() * (10) + 10 AS INTEGER);

		INSERT INTO Teherauto VALUES (
			alvszam,
			uanyag,
			gyar,
			tip,
			'{}',
			kapacitas
		);
		i = i + 1;
		j = 0;
		alvszam = CAST (CAST(random()*9 AS INTEGER) AS CHARACTER VARYING);
	END LOOP;
END IF; 
END
$$ LANGUAGE plpgsql VOLATILE COST 100;

--SELECT Jarmu_generator(100, 'szemelyauto');