﻿/*CREATE TABLE Jarmu (
	Alvazszam CHARACTER VARYING,
	Uzemanyag CHARACTER VARYING,
	Gyarto CHARACTER VARYING,
	Tipus CHARACTER VARYING,
	Tankolasok TankolasRekord[],
	PRIMARY KEY (Alvazszam)
);*/

--update jarmu set Tankolasok[array_length(Tankolasok, 1)+1] = row('2012-11-22', 'ffefwfe', 21.212) where Alvazszam = 'wwsq';

/*
 * Új tankolási bejegyzés felvételéhez meghatározza a következő szabad indexértéket
 * egy Jarmu típusú rekordra.
 * Szerző: Cser Lajos, Szegedi Tudományegyetem, 2012. december 29.
 */
CREATE OR REPLACE FUNCTION UjTankolas(Jarmu) RETURNS INTEGER AS $$
SELECT COALESCE(array_length($1.Tankolasok, 1)+1, 1);
$$ LANGUAGE SQL;

--INSERT INTO Jarmu VALUES ('1M8GDM9A_KP042788', 'benzin', 'Toyota', 'Corolla', '{}');
UPDATE jarmu SET Tankolasok[Jarmu.UjTankolas] = ROW('2012-01-22', '0585/00077', 21.212) WHERE Alvazszam = '1M8GDM9A_KP042788';

SELECT tankolasok[2].datum FROM jarmu WHERE alvazszam = '1M8GDM9A_KP042788';

/*
 * Meghatározza egy Jarmu rekordra nézve az adott jármű adott éves fogyasztását. 
 * Első argumentuma a feldolgozandó rekordot azonosítja, a második az év, amely
 * szerint összesíteni kell.
 * Visszatérési érték: az éves fogyasztás.
 * Szerző: Cser Lajos, Szegedi Tudományegyetem, 2012. december 29.
 */
CREATE OR REPLACE FUNCTION Fogyasztas(Jarmu, INTEGER) RETURNS REAL AS $$
DECLARE
	sum REAL = 0.0;
	i INTEGER = 1;
BEGIN
	WHILE i <= array_length($1.Tankolasok, 1) LOOP
	BEGIN
		IF (EXTRACT(YEAR FROM $1.Tankolasok[i].Datum) = $2) THEN
			sum = sum + $1.Tankolasok[i].Liter;
		END IF;
		i = i + 1;
	END;
	END LOOP;
	RETURN sum;
END;
$$ LANGUAGE plpgsql;

/*
 * Meghatározza egy Jarmu rekordra nézve az adott jármű eddigi összes
 * fogyasztását. 
 * Első argumentuma a feldolgozandó rekordot azonosítja.
 * Visszatérési érték: a fogyasztás.
 * Szerző: Cser Lajos, Szegedi Tudományegyetem, 2012. december 29.
 */
CREATE OR REPLACE FUNCTION OsszFogyasztas(Jarmu) RETURNS REAL AS $$
DECLARE
	sum REAL := 0.0;
	i INTEGER := 1;
BEGIN
	WHILE i <= array_length($1.Tankolasok, 1) LOOP
	BEGIN
		sum := sum + $1.Tankolasok[i].Liter;
		i := i + 1;
	END;
	END LOOP;
	RETURN sum;
END;
$$ LANGUAGE plpgsql;

select j.Alvazszam, Fogyasztas(j, 2012), j.OsszFogyasztas FROM Jarmu j;


/* ************************ Dolgozo **************************** */

CREATE TYPE Szerzodes AS (
	Reszletezes TEXT,
	Probaido BOOLEAN,
	ProbaidoHossz INTEGER
);

CREATE TABLE Dolgozo (
	Nev CHARACTER VARYING NOT NULL,
	SzemelyiSzam CHARACTER VARYING NOT NULL,
	SzuletesiDatum DATE,
	Beosztas CHARACTER VARYING,
	Szerzodese Szerzodes,
	PRIMARY KEY (SzemelyiSzam)
);


INSERT INTO Dolgozo VALUES (
	'Horváth Emese',
	'19760130-0941-2',
	'1976-01-30',
	'egyéb ügyintéző',
	ROW(
		'MUNKASZERZŐDÉS amely létrejött a Gazdálkodó Kft., mint munkáltató, valamint Horváth Emese, szül. 1976. 01. 30., mint munkavállaló közt, az alábbi feltételekkel: 1. Munkavállaló és munkáltató megállapodnak abban, hogy próbaidő nélkül, 2012. 10. 01. napjától határozatlan időtartamú munkajogviszony keretében a munkáltató foglalkoztatja a munkavállalót. 2. A munkáltató a munkavállalót havi 160 órában foglalkoztatja. 3. A munkavállaló havi személyi bruttó alapbére 140 000 Ft. Kelt Szeged, 2012. 10. 01.',
		FALSE,
		0
	)
);

SELECT Nev, SzemelyiSzam, SzuletesiDatum, Beosztas, 
CASE 
	WHEN(Szerzodese).Probaido = FALSE THEN 'nem' 
	ELSE 'igen'
END AS Probaidos 
FROM Dolgozo;